package com.jakubu9333.grammarManager.dao;

import com.jakubu9333.grammarManager.model.Rule;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.stereotype.Repository;

import java.util.List;
import java.util.Optional;

/**
 * @author Jakub Uhlarik
 */
@Repository
public interface RuleRepository extends JpaRepository<Rule, Long> {

    List<Rule> findByLeftSymbol(String leftSide);

    Optional<Rule> findByIdAndGrammar_Id(Long id, Long grammarId);

    List<Rule> findByLeftSymbolAndGrammar_Id(String leftSide, Long GrammarId);
}
